package org.postgis;

import static org.fest.assertions.Assertions.assertThat;

import org.junit.Before;
import org.junit.Test;

/**
 * This test is here because not every version of postgis passes this test.
 */
public class LineStringTest {

    private LineString lsAB;
    private LineString lsBC;
    private LineString lsCD;
    private LineString lsABCD;

    @Before
    public void setup() {
        // Given
        final Point pointA = new Point(1, 1);
        final Point pointB = new Point(2, 2);
        final Point pointC = new Point(3, 3);
        final Point pointD = new Point(4, 4);

        final Point[] pointsAB = new Point[] { pointA, pointB };
        final Point[] pointsBC = new Point[] { pointB, pointC };
        final Point[] pointsCD = new Point[] { pointC, pointD };

        final Point[] pointsABCD = new Point[] { pointA, pointB, pointC, pointD };

        lsAB = new LineString(pointsAB);
        lsBC = new LineString(pointsBC);
        lsCD = new LineString(pointsCD);
        lsABCD = new LineString(pointsABCD);

    }

    @Test
    public void shouldConcatLineStrings() {

        // When
        final LineString concatenatedABBCCD = lsAB.concat(lsBC).concat(lsCD);

        // Then
        assertThat(concatenatedABBCCD).isEqualTo(lsABCD);

    }
}
